
from cyclarity_sdk.platform_api.Iplatform_connector import IPlatformConnectorApi   # noqa
from cyclarity_sdk.sdk_models.artifacts import TestArtifact
from cyclarity_sdk.sdk_models.findings import Finding
from cyclarity_sdk.sdk_models import ExecutionState
from clarity_common import ExecutionMetadata   # noqa
import requests


class RestConnector(IPlatformConnectorApi):
    def __init__(self, execution_metadata: ExecutionMetadata, token):  # noqa
        self.execution_metadata = execution_metadata
        self.headers = {
            'Content-Type': 'application/json',
            'Authorization': f'Bearer {token}'
        }

    def send_artifact(self, test_artifact: TestArtifact):
        url = '/api/testing/artifacts'
        data = test_artifact.model_dump_json()
        response = requests.post(url, headers=self.headers, data=data)
        return response.status_code

    def send_finding(self, finding: Finding):
        url = '/finding'  # TODO
        data = finding.model_dump_json()
        response = requests.post(url, headers=self.headers, data=data)
        return response.status_code

    def send_state(self, execution_state: ExecutionState):
        url = '/state'  # TODO
        data = execution_state.model_dump_json()
        response = requests.post(url, headers=self.headers, data=data)
        return response.status_code

    def get_execution_meta_data(self) -> ExecutionMetadata:
        return self.execution_metadata
